// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'TLMIniFilter.pas' rev: 6.00

#ifndef TLMIniFilterHPP
#define TLMIniFilterHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <TLMSystem.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <Registry.hpp>	// Pascal unit
#include <IniFiles.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Tlminifilter
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TtlmIniFilter;
class PASCALIMPLEMENTATION TtlmIniFilter : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FActive;
	bool FCustomLanguageFiles;
	Classes::TStrings* FLanguageFiles;
	bool FCustomLanguageExt;
	AnsiString FLanguageExt;
	bool FSaveSettings;
	bool FAddBracket;
	Inifiles::TIniFile* FIniFile;
	Classes::TStrings* FLoadedLanguageFiles;
	int FActiveLanguage;
	HIDESBASE int __stdcall _AddRef(void);
	HIDESBASE int __stdcall _Release(void);
	bool __fastcall IsValidLangFile(AnsiString FileName);
	void __fastcall SearchAllFiles(Classes::TStrings* AList);
	void __fastcall PrepareFiles(Classes::TStrings* AList, const Classes::TStrings* ASrcList);
	void __fastcall LoadLanguageFiles(void);
	AnsiString __fastcall GetSystemLangExt();
	AnsiString __fastcall GetUserLangExt();
	void __fastcall SaveLangExt(const AnsiString Ext);
	AnsiString __fastcall GetLanguageName(const AnsiString AFileName);
	int __fastcall GetLangExtIndex(const AnsiString ALangExt);
	void __fastcall SetActive(bool AValue);
	void __fastcall SetLanguageFiles(Classes::TStrings* AValue);
	void __fastcall OnLangMenuItemClick(System::TObject* Sender);
	
protected:
	virtual HRESULT __stdcall QueryInterface(const GUID &IID, /* out */ void *Obj);
	void __fastcall LoadLanguages(void);
	void __fastcall SetActiveLanguage(const int AValue);
	int __fastcall GetActiveLanguage(void);
	void __fastcall GetGeneralInfo(Tlmsystem::TGeneralInfo &AInfo);
	int __fastcall Translate(const AnsiString ASection, const AnsiString AKey, const int ADefault)/* overload */;
	AnsiString __fastcall Translate(const AnsiString ASection, const AnsiString AKey, const AnsiString ADefault)/* overload */;
	virtual void __fastcall Loaded(void);
	
public:
	__fastcall virtual TtlmIniFilter(Classes::TComponent* AOwner);
	__fastcall virtual ~TtlmIniFilter(void);
	__property int ActiveLanguage = {read=GetActiveLanguage, write=SetActiveLanguage, nodefault};
	void __fastcall GetLoadedLanguageFiles(Classes::TStrings* AList);
	void __fastcall GetLoadedLanguages(Classes::TStrings* AList);
	void __fastcall GenerateLanguageMenu(Menus::TMenuItem* AMenu);
	
__published:
	__property bool CustomLanguageFiles = {read=FCustomLanguageFiles, write=FCustomLanguageFiles, default=0};
	__property Classes::TStrings* LanguageFiles = {read=FLanguageFiles, write=SetLanguageFiles};
	__property bool CustomLanguageExt = {read=FCustomLanguageExt, write=FCustomLanguageExt, default=0};
	__property AnsiString LanguageExt = {read=FLanguageExt, write=FLanguageExt};
	__property bool SaveSettings = {read=FSaveSettings, write=FSaveSettings, default=1};
	__property bool AddBracket = {read=FAddBracket, write=FAddBracket, default=0};
	__property bool Active = {read=FActive, write=SetActive, default=1};
private:
	void *__ILangFilter;	/* Tlmsystem::ILangFilter */
	
public:
	operator ILangFilter*(void) { return (ILangFilter*)&__ILangFilter; }
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Tlminifilter */
using namespace Tlminifilter;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// TLMIniFilter
